;
;	framz8ca.s
;
;	P/ECE Z80 Emulator ()
;
;	CLiP - Common Library for P/ECE
;	Copyright (C) 2001-2005 Naoyuki Sawa
;
;	* Mon Jan 10 19:00:00 JST 2005 Naoyuki Sawa
;	- 쐬JnB
;
#include "clipz8ca.h"

;****************************************************************************
;	
;****************************************************************************

	.code
	.align 2

	; ̂߁AZ80CPU\̂RAMɔzu܂B
	.global z80cpu
z80cpu:
	.space SIZEOF_Z80CPU

	.code
	.align 1

;****************************************************************************
;	
;****************************************************************************

	.global z80cpu_run
z80cpu_run:
	pushn %r3
	;
	xld.w [z80cpu+_CYCLE_], %r12	; sReLXgo܂B
	xcall z80cpu_enter
	;
	xbtst [%CPU+HALT], 0		; HALTȂΉ܂B
	xjrne z80cpu_run_EXIT
	;
	xjp z80cpu_run_LOOP		; Cycle=0w肳ꂽꍇ̂߂ɁA܂肩B
z80cpu_run_DO:
//#define Z80CPU_RUN_TRACE
#ifdef Z80CPU_RUN_TRACE
	; g[XfobOsꍇ́ÃubNLɂĂB
	; ̍ہAz80cpu_trace()́AAvP[VɂĒ`ĂB
	; z80cpu_trace()́ACuł͒`Ă܂B
	xcall z80cpu_leave
	xcall z80cpu_trace
	xcall z80cpu_enter
#endif /*Z80CPU_RUN_TRACE*/
	ld.ub  %t0, [%PC]+		; OpCode擾APCi߂܂B
	xsll   %t0, 2			; OpCodeɑΉ閽߃[`Ăяo܂B
	ext z80cpu_XXops@ah
	ext z80cpu_XXops@al
	ld.w   %t0, [%t0]
	call   %t0
z80cpu_run_LOOP:
	xcmp   %CYCLE, 0		; Cycle0ȉɂȂ܂ŌJԂ܂B
	xjrgt z80cpu_run_DO
	;
z80cpu_run_EXIT:
	xcall z80cpu_leave		; sReLXg߂܂B
	;
	popn %r3
	ret

;
;	CB xx
;	   ++- OpCode
;
	.global z80cpu_CB
z80cpu_CB:
	ld.ub %t0, [%PC]+		; OpCode
	xsll  %t0, 2
	ext z80cpu_CBops@ah
	ext z80cpu_CBops@al
	ld.w  %t0, [%t0]
	jp    %t0

;
;	ED xx
;	   ++- OpCode
;
	.global z80cpu_ED
z80cpu_ED:
	ld.ub %t0, [%PC]+		; OpCode
	xsll  %t0, 2
	ext z80cpu_EDops@ah
	ext z80cpu_EDops@al
	ld.w  %t0, [%t0]
	jp %t0

;
;	DD xx
;	   ++- OpCode
;
	.global z80cpu_DD
z80cpu_DD:
	ld.ub %t0, [%PC]+		; OpCode
	xsll  %t0, 2
	ext z80cpu_DDops@ah
	ext z80cpu_DDops@al
	ld.w  %t0, [%t0]
	jp %t0

;
;	FD xx
;	   ++- OpCode
;
	.global z80cpu_FD
z80cpu_FD:
	ld.ub %t0, [%PC]+		; OpCode
	xsll  %t0, 2
	ext z80cpu_FDops@ah
	ext z80cpu_FDops@al
	ld.w  %t0, [%t0]
	jp %t0

;
;	DD CB d xx
;	      | ++- OpCode
;	      +---- IX+"d"
;
	.global z80cpu_DDCB
z80cpu_DDCB:
	xld.uh %s0, [%CPU+IX]		; %s0 = &z80mem[IX+d(signed)]
	ld.b   %t0, [%PC]+
	add    %s0, %t0
	add    %s0, %MEM
	ld.ub  %t0, [%PC]+		; OpCode
	xsll   %t0, 2
	ext z80cpu_XXCBops@ah
	ext z80cpu_XXCBops@al
	ld.w   %t0, [%t0]
	jp     %t0

;
;	FD CB d xx
;	      | ++- OpCode
;	      +---- IY+"d"
;
	.global z80cpu_FDCB
z80cpu_FDCB:
	xld.uh %s0, [%CPU+IY]		; %s0 = &z80mem[IY+d(signed)]
	ld.b   %t0, [%PC]+
	add    %s0, %t0
	add    %s0, %MEM
	ld.ub  %t0, [%PC]+		; OpCode
	xsll   %t0, 2
	ext z80cpu_XXCBops@ah
	ext z80cpu_XXCBops@al
	ld.w   %t0, [%t0]
	jp     %t0

;****************************************************************************
;	16-Bit Load Group
;****************************************************************************

;
;	PUSH rr
;	     ++-< %a0
;
	.global z80cpu_push
z80cpu_push:
	xld.uh %t0, [%CPU+SP]		; Load SP
	add    %t0, %MEM
	xrr    %a0, 8			; *--SP = HI(rr)
	xsub   %t0, %t0, 1
	ld.b  [%t0], %a0
	xrl    %a0, 8			; *--SP = LO(rr)
	xsub   %t0, %t0, 1
	ld.b  [%t0], %a0
	sub    %t0, %MEM		; Store SP
	xld.h [%CPU+SP], %t0
	ret

;
;	POP rr
;	    ++-> %a0
;
	.global z80cpu_pop
z80cpu_pop:
	xld.uh %t0, [%CPU+SP]		; Load SP
	add    %t0, %MEM
	ld.ub  %a0, [%t0]+		; *SP++ = LO(rr)
	ld.ub  %a1, [%t0]+		; *SP++ = HI(rr)
	sub    %t0, %MEM		; Store SP
	xld.h [%CPU+SP], %t0
	xsll   %a1, 8			; RR = LO(rr)|HI(rr)<<8
	ret.d
	or     %a0, %a1			; *delay*

;****************************************************************************
;	8-Bit Arithmetic Group
;****************************************************************************

;
;	ADD A, r
;	       +-< %a0
;
;	S	is set if result is negative, reset otherwise
;	Z	is set if result is zero, reset otherwise
;	H	is set if carry from bit 3, reset otherwise
;	P/V	is set if overflow, reset otherwise
;	N	is reset
;	C	is set if carry from bit 7, reset otherwise
;
	.global z80cpu_add8
z80cpu_add8:
	swap %t0, %A			; %t0[31:24] = A+r
	swap %t1, %a0
	add  %t0, %t1
	;
	ld.w %F, %psr			; F = F(0HCPZS)
	xand %F, %F, CF|PF|ZF|SF
	xand %A, %A, 0xf
	xand %a0, %a0, 0xf
	add  %A, %a0
	xand %A, %A, HF
	or   %F, %A
	;
	ret.d
	swap %A, %t0			; A = A+r *delay*

;
;	ADC A, r
;	       +-< %a0
;
;	S	is set if result is negative, reset otherwise
;	Z	is set if result is zero, reset otherwise
;	H	is set if carry from bit 3, reset otherwise
;	P/V	is set if overflow, reset otherwise
;	N	is reset
;	C	is set if carry from bit 7: reset otherwise
;
	.global z80cpu_adc8
z80cpu_adc8:
	ld.w  %t2, %psr			; %t2 = F(C)
	xand  %t2, %t2, ~CF
	xand  %F, %F, CF
	or    %t2, %F
	;
	swap  %t0, %A			; %t0[31:24] = A+r+F(C)
	swap  %t1, %a0
	xoor  %t1, %t1, (1<<24)-1
	ld.w  %psr, %t2
	adc   %t0, %t1
	;
	ld.w  %F, %psr			; F = F(0HCP0S)
	xand  %F, %F, CF|PF|SF		; (%t0[23:0]sA%psr(Z)͂܂m肵Ȃ)
	xand  %A, %A, 0xf
	xand  %a0, %a0, 0xf
	ld.w  %psr, %t2
	adc   %A, %a0
	xand  %A, %A, HF
	or    %F, %A
	;
	swap  %A, %t0			; A = A+r+F(C)
	ld.ub %A, %A
	or    %A, %A			; F = F(0HCPZS)
	jrne  2
	add   %F, ZF			; (skip?)
	ret

;
;	SUB r
;	    +-< %a0
;
;	S	is set if result is negative, reset otherwise
;	Z	is set if result is zero, reset otherwise
;	H	is set if borrow from bit 4, reset otherwise
;	P/V	is set if overflow, reset otherwise
;	N	is set
;	C	is set if borrow, reset otherwise
;
	.global z80cpu_sub8
z80cpu_sub8:
	swap %t0, %A			; %t0[31:24] = A-r
	swap %t1, %a0
	sub  %t0, %t1
	;
	ld.w %F, %psr			; F = F(1HCPZS)
	xand %F, %F, CF|PF|ZF|SF
	xadd %F, %F, NF
	xand %A, %A, 0xf
	xand %a0, %a0, 0xf
	sub  %A, %a0
	xand %A, %A, HF
	or   %F, %A
	;
	ret.d
	swap %A, %t0			; A = A-r *delay*

;
;	SBC A, r
;	       +-< %a0
;
;	S	is set if result is negative, reset otherwise
;	Z	is set if result is zero, reset otherwise
;	H	is set if borrow from bit 4, reset otherwise
;	P/V	is reset if overflow, reset otherwise
;	N	is set
;	C	is set if borrow, reset otherwise
;
	.global z80cpu_sbc8
z80cpu_sbc8:
	ld.w  %t2, %psr			; %t2 = F(C)
	xand  %t2, %t2, ~CF
	xand  %F, %F, CF
	or    %t2, %F
	;
	swap  %t0, %A			; %t0[31:24] = A-r-F(C)
	swap  %t1, %a0
	ld.w  %psr, %t2
	sbc   %t0, %t1
	;
	ld.w  %F, %psr			; F = F(1HCP0S)
	xand  %F, %F, CF|PF|SF		; (%t0[23:0]sA%psr(Z)͂܂m肵Ȃ)
	xadd  %F, %F, NF
	xand  %A, %A, 0xf
	xand  %a0, %a0, 0xf
	ld.w  %psr, %t2
	sbc   %A, %a0
	xand  %A, %A, HF
	or    %F, %A
	;
	swap  %A, %t0			; A = A-r-F(C)
	ld.ub %A, %A
	or    %A, %A			; F = F(1HCPZS)
	jrne  2
	add   %F, ZF			; (skip?)
	ret

;
;	AND r
;	    +-< %a0
;
;	S	is set if result is negative, reset otherwise
;	Z	is set if result is zero, reset otherwise
;	H	is set
;	P/V	is set if parity is even, reset otherwise
;	N	is reset
;	C	is reset
;
	.global z80cpu_and
z80cpu_and:
	swap  %t0, %A			; %t0[31:24] = A&r
	swap  %t1, %a0
	and   %t0, %t1
	;
	ld.w  %F, %psr			; F = F(010PZS)
	xand  %F, %F, ZF|SF
	xadd  %F, %F, HF
	swap  %A, %t0			; A = A&r
	ext z80cpu_parity@ah
	ext z80cpu_parity@al
	ld.ub %t0, [%A]
	ret.d
	or    %F, %t0			; *delay*

;
;	OR r
;	   +-< %a0
;
;	S	is set if result is negative, reset otherwise
;	Z	is set if result is zero, reset otherwise
;	H	is reset
;	P/V	is set if parity is even, reset otherwise
;	N	is reset
;	C	is reset
;
	.global z80cpu_or
z80cpu_or:
	swap  %t0, %A			; %t0[31:24] = A|r
	swap  %t1, %a0
	or    %t0, %t1
	;
	ld.w  %F, %psr			; F = F(000PZS)
	xand  %F, %F, ZF|SF
	swap  %A, %t0			; A = A|r
	ext z80cpu_parity@ah
	ext z80cpu_parity@al
	ld.ub %t0, [%A]
	ret.d
	or    %F, %t0			; *delay*

;
;	XOR r
;	    +-< %a0
;
;	S	is set if result is negative, reset otherwise
;	Z	is set if result is zero, reset otherwise
;	H	is reset
;	P/V	is set if parity is even, reset otherwise
;	N	is reset
;	C	is reset
;
	.global z80cpu_xor
z80cpu_xor:
	swap  %t0, %A			; %t0[31:24] = A^r
	swap  %t1, %a0
	xor   %t0, %t1
	;
	ld.w  %F, %psr			; F = F(000PZS)
	xand  %F, %F, ZF|SF
	swap  %A, %t0			; A = A^r
	ext z80cpu_parity@ah
	ext z80cpu_parity@al
	ld.ub %t0, [%A]
	ret.d
	or    %F, %t0			; *delay*

;
;	CP r
;	    +-< %a0
;
;	S	is set if result is negative, reset otherwise
;	Z	is set if result is zero, reset otherwise
;	H	is set if borrow from bit 4, reset otherwise
;	P/V	is set if overflow, reset otherwise
;	N	is set
;	C	is set if borrow, reset otherwise
;
	.global z80cpu_cp
z80cpu_cp:
	swap %t0, %A			; %t0[31:24] = A-r
	swap %t1, %a0
	cmp  %t0, %t1
	;
	ld.w %F, %psr			; F = F(1HCPZS)
	xand %F, %F, CF|PF|ZF|SF
	xadd %F, %F, NF
	xand %t0, %A, 0xf
	xand %a0, %a0, 0xf
	sub  %t0, %a0
	xand %t0, %t0, HF
	;
	ret.d
	or   %F, %t0			; *delay*

;
;	INC r
;	    +-<> %a0
;
;	S	is set if result is negative, reset otherwise
;	Z	is set if result is zero, reset otherwise
;	H	is set if carry from bit 3, reset otherwise
;	P/V	is set if r was 7FH before operation, reset otherwise
;	N	is reset
;	C	is not affected
;
	.global z80cpu_inc8
z80cpu_inc8:
	xand %t1, %F, CF
	swap %t0, %a0			; %t0[31:24] = r+1
	xadd %t0, %t0, 1<<24
	;
	ld.w %F, %psr			; F = F(0H-PZS)
	xand %F, %F, PF|ZF|SF
	xand %a0, %a0, 0xf
	xadd %a0, %a0, 1
	xand %a0, %a0, HF
	or   %F, %a0
	or   %F, %t1
	;
	ret.d
	swap %a0, %t0			; r = r+1 *delay*

;
;	DEC r
;	    +-<> %a0
;
;	S	is set if result is negative, reset otherwise
;	Z	is set if result is zero, reset otherwise
;	H	is set if borrow from bit 4, reset otherwise
;	P/V	is set if m was 80H before operation, reset otherwise
;	N	is set
;	C	is not affected
;
	.global z80cpu_dec8
z80cpu_dec8:
	xand %t1, %F, CF
	swap %t0, %a0			; %t0[31:24] = r-1
	xsub %t0, %t0, 1<<24
	;
	ld.w %F, %psr			; F = F(1H-PZS)
	xand %F, %F, PF|ZF|SF
	xadd %F, %F, NF
	xand %a0, %a0, 0xf
	xsub %a0, %a0, 1
	xand %a0, %a0, HF
	or   %F, %a0
	or   %F, %t1
	;
	ret.d
	swap %a0, %t0			; r = r-1 *delay*

;****************************************************************************
;	16-Bit Arithmetic Group
;****************************************************************************

;
;	ADD rr, ss
;	    ||  ++-<  %a1
;	    ++-----<> %a0
;
;	S	is not affected
;	Z	is not affected
;	H	is set if carry out of bit 11, reset otherwise
;	P/V	is not affected
;	N	is reset
;	C	is set if carry from bit 15, reset otherwise
;
	.global z80cpu_add16
z80cpu_add16:
	xand %t2, %F, PF|ZF|SF
	ld.w %t0, %a0			; %t0[31:16] = rr+ss
	xsll %t0, 16
	ld.w %t1, %a1
	xsll %t1, 16
	add  %t0, %t1
	;
	ld.w %F, %psr			; F = F(0HC---)
	xand %F, %F, CF
	xand %a0, %a0, 0xfff
	xand %a1, %a1, 0xfff
	add  %a0, %a1
	xsrl %a0, 8
	xand %a0, %a0, HF
	or   %F, %a0
	or   %F, %t2
	;
	xsrl %t0, 16			; rr = rr+ss
	ret.d
	ld.w %a0, %t0			; *delay*

;
;	ADC rr, ss
;	    ||  ++-<  %a1
;	    ++-----<> %a0
;
;	S	is set if result is negative, reset otherwise
;	Z	is set if result is zero, reset otherwise
;	H	is set if carry out of bit 11, reset otherwise
;	P/V	is set if overflow, reset otherwise
;	N	is reset
;	C	is set if carry from bit 15, reset otherwise
;
	.global z80cpu_adc16
z80cpu_adc16:
	ld.w %t2, %psr			; %t2 = F(C)
	xand %t2, %t2, ~CF
	xand %F, %F, CF
	or   %t2, %F
	;
	ld.w %t0, %a0			; %t0[31:16] = rr+ss+F(C)
	xsll %t0, 16
	ld.w %t1, %a1
	xsll %t1, 16
	xoor %t1, %t1, (1<<16)-1
	ld.w %psr, %t2
	adc  %t0, %t1
	;
	ld.w %F, %psr			; F = F(0HCP0S)
	xand %F, %F, CF|PF|SF		; (%t0[23:0]sA%psr(Z)͂܂m肵Ȃ)
	xand %a0, %a0, 0xfff
	xand %a1, %a1, 0xfff
	ld.w %psr, %t2
	adc  %a0, %a1
	xsrl %a0, 8
	xand %a0, %a0, HF
	or   %F, %a0
	;
	xsrl %t0, 16			; rr = rr+ss+F(C)
	jrne 2				; F = F(0HCPZS)
	add  %F, ZF			; (skip?)
	ret.d
	ld.w %a0, %t0			; *delay*

;
;	SBC rr, ss
;	    ||  ++-<  %a1
;	    ++-----<> %a0
;
;	S is set if result is negative, reset otherwise
;	Z is set if result is zero, reset otherwise
;	H is set if a borrow from bit 12, reset otherwise
;	P/V is set if overflow, reset otherwise
;	N is set
;	C is set if borrow, reset otherwise
;
	.global z80cpu_sbc16
z80cpu_sbc16:
	ld.w %t2, %psr			; %t2 = F(C)
	xand %t2, %t2, ~CF
	xand %F, %F, CF
	or   %t2, %F
	;
	ld.w %t0, %a0			; %t0[31:16] = rr-ss-F(C)
	xsll %t0, 16
	ld.w %t1, %a1
	xsll %t1, 16
	ld.w %psr, %t2
	sbc  %t0, %t1
	;
	ld.w %F, %psr			; F = F(1HCP0S)
	xand %F, %F, CF|PF|SF		; (%t0[23:0]sA%psr(Z)͂܂m肵Ȃ)
	xadd %F, %F, NF
	xand %a0, %a0, 0xfff
	xand %a1, %a1, 0xfff
	ld.w %psr, %t2
	sbc  %a0, %a1
	xsrl %a0, 8
	xand %a0, %a0, HF
	or   %F, %a0
	;
	xsrl %t0, 16			; rr = rr-ss-F(C)
	jrne 2				; F = F(1HCPZS)
	add  %F, ZF			; (skip?)
	ret.d
	ld.w %a0, %t0			; *delay*

;****************************************************************************
;	Rotate and Shift Group
;****************************************************************************

;
;	S	is set if result is negative, reset otherwise
;	Z	is set if result is zero, reset otherwise
;	H	is reset
;	P/V	is set if parity is even, reset otherwise
;	N	is reset
;	C	is data from bit 7 of source register
;
	.global z80cpu_rl
z80cpu_rl:
	ld.w  %t0, %a0
	xsll  %a0, 1
	xand  %F, %F, CF
	xsrl  %F, 3-0
	or    %a0, %F
	ld.b  %a0, %a0			; %a0 = RL(r) (signed)
	or    %a0, %a0			; (%psrɔf邽ߕKv)
	;
	ld.w  %F, %psr			; F = F(00CPZS)
	and   %F, ZF|SF
	xsrl  %t0, 7-3
	xand  %t0, %t0, CF
	or    %F, %t0
	ld.ub %a0, %a0			; %a0 = RL(r) (unsigned)
	ext z80cpu_parity@ah
	ext z80cpu_parity@al
	ld.ub %t0, [%a0]
	ret.d
	or    %F, %t0			; *delay*

;
;	S	is set if result is negative, reset otherwise
;	Z	is set if result is zero, reset otherwise
;	H	is reset
;	P/V	is set if parity is even, reset otherwise
;	N	is reset
;	C	is data from bit 7 of source register
;
	.global z80cpu_rlc
z80cpu_rlc:
	ld.w  %t0, %a0
	ld.w  %t1, %a0
	xsll  %a0, 1
	xsrl  %t1, 7
	or    %a0, %t1
	ld.b  %a0, %a0			; %a0 = RLC(r) (signed)
	or    %a0, %a0			; (%psrɔf邽ߕKv)
	;
	ld.w  %F, %psr			; F = F(00CPZS)
	and   %F, ZF|SF
	xsrl  %t0, 7-3
	xand  %t0, %t0, CF
	or    %F, %t0
	ld.ub %a0, %a0			; %a0 = RLC(r) (unsigned)
	ext z80cpu_parity@ah
	ext z80cpu_parity@al
	ld.ub %t0, [%a0]
	ret.d
	or    %F, %t0			; *delay*

;
;	S	is set if result is negative, reset otherwise
;	Z	is set if result is zero, reset otherwise
;	H	is reset
;	P/V	is set if parity is even, reset otherwise
;	N	is reset
;	C	is data from bit 0 of source register
;
	.global z80cpu_rr
z80cpu_rr:
	ld.w  %t0, %a0
	xsrl  %a0, 1
	xand  %F, %F, CF
	xsll  %F, 7-3
	or    %a0, %F
	ld.b  %a0, %a0			; %a0 = RR(r) (signed)
	or    %a0, %a0			; (%psrɔf邽ߕKv)
	;
	ld.w  %F, %psr			; F = F(00CPZS)
	and   %F, ZF|SF
	xsll  %t0, 3-0
	xand  %t0, %t0, CF
	or    %F, %t0
	ld.ub %a0, %a0			; %a0 = RR(r) (unsigned)
	ext z80cpu_parity@ah
	ext z80cpu_parity@al
	ld.ub %t0, [%a0]
	ret.d
	or    %F, %t0			; *delay*

;
;	S	is set if result is negative, reset otherwise
;	Z	is set if result is zero, reset otherwise
;	H	is reset
;	P/V	is set if parity is even, reset otherwise
;	N	is reset
;	C	is data from bit 0 of source register
;
	.global z80cpu_rrc
z80cpu_rrc:
	ld.w  %t0, %a0
	ld.w  %t1, %a0
	xsrl  %a0, 1
	xsll  %t1, 7
	or    %a0, %t1
	ld.b  %a0, %a0			; %a0 = RRC(r) (signed)
	or    %a0, %a0			; (%psrɔf邽ߕKv)
	;
	ld.w  %F, %psr			; F = F(00CPZS)
	and   %F, ZF|SF
	xsll  %t0, 3-0
	xand  %t0, %t0, CF
	or    %F, %t0
	ld.ub %a0, %a0			; %a0 = RRC(r) (unsigned)
	ext z80cpu_parity@ah
	ext z80cpu_parity@al
	ld.ub %t0, [%a0]
	ret.d
	or    %F, %t0			; *delay*

;
;	S	is set if result is negative, reset otherwise
;	Z	is set if result is zero, reset otherwise
;	H	is reset
;	P/V	is set if parity is even, reset otherwise
;	N	is reset
;	C	is data from bit 7
;
	.global z80cpu_sla
z80cpu_sla:
	ld.w  %t0, %a0
	xsll  %a0, 1
	ld.b  %a0, %a0			; %a0 = SLA(r) (signed)
	or    %a0, %a0			; (%psrɔf邽ߕKv)
	;
	ld.w  %F, %psr			; F = F(00CPZS)
	and   %F, ZF|SF
	xsrl  %t0, 7-3
	xand  %t0, %t0, CF
	or    %F, %t0
	ld.ub %a0, %a0			; %a0 = SLA(r) (unsigned)
	ext z80cpu_parity@ah
	ext z80cpu_parity@al
	ld.ub %t0, [%a0]
	ret.d
	or    %F, %t0			; *delay*

;
;	S	is set if result is negative, reset otherwise
;	Z	is set if result is zero, reset otherwise
;	H	is reset
;	P/V	is set if parity is even, reset otherwise
;	N	is reset
;	C	is data from bit 0 of source register
;
	.global z80cpu_sra
z80cpu_sra:
	ld.w  %t0, %a0
	ld.b  %a0, %a0
	xsra  %a0, 1			; %a0 = SRA(r) (signed)
	;;or  %a0, %a0			; (sv)
	;
	ld.w  %F, %psr			; F = F(00CPZS)
	and   %F, ZF|SF
	xsll  %t0, 3-0
	xand  %t0, %t0, CF
	or    %F, %t0
	ld.ub %a0, %a0			; %a0 = SRA(r) (unsigned)
	ext z80cpu_parity@ah
	ext z80cpu_parity@al
	ld.ub %t0, [%a0]
	ret.d
	or    %F, %t0			; *delay*

;
;	S	is reset
;	Z	is set if result is zero, reset otherwise
;	H	is reset
;	P/V	is set if parity is even, reset otherwise
;	N	is reset
;	C	is data from bit 0 of source register
;
	.global z80cpu_srl
z80cpu_srl:
	ld.w %t0, %a0
	xsrl %a0, 1			; %a0 = SRL(r) (signed)
	;;or %a0, %a0			; (sv)
	;
	ld.w  %F, %psr			; F = F(00CPZS)
	and   %F, ZF|SF
	xsll  %t0, 3-0
	xand  %t0, %t0, CF
	or    %F, %t0
	ld.ub %a0, %a0			; %a0 = SRL(r) (unsigned)
	ext z80cpu_parity@ah
	ext z80cpu_parity@al
	ld.ub %t0, [%a0]
	ret.d
	or    %F, %t0			; *delay*

;****************************************************************************
;	Bit Set, Reset, and Test Group
;****************************************************************************

;
;	BIT b, r
;	    |  +-< %a1
;	    +----< %a0
;
;	S	is unknown
;		  Undoc'd
;		  (b=7)(r[7]=1)̏ꍇsetAȂreset܂B
;		  SG-1000p`bvt^[́A̋ɈˑĂ܂B
;	Z	is set if specified bit is 0, reset otherwise
;	H	is set
;	P/V	is unknown
;		  Undoc'd
;		  ZtOƓlɂȂ܂B
;	N	is reset
;	C	is not affected
;
	.global z80cpu_bit
z80cpu_bit:
	xand  %F, %F, CF		; %F = F(01-000)
	xadd  %F, %F, HF
	;
	xld.w %t0, 1<<24		; %t10[31:24] = 1<<b
	sll   %t0, %a0			; (%a0=0..7Axsllł͏璷)
	swap  %a1, %a1			; %a1[31:24] = r
	and   %a1, %t0			; r &= 1<<b
	;
	ld.w  %t0, %psr			; %t0 = F(000PZS)
	jrne.d 3
	and   %t0, ZF|SF		; *delay*
	add   %t0, PF			; (skip?)
	;
	ret.d
	or    %F, %t0			; %F = F(01-PZS) *delay*

;****************************************************************************
;	Input and Output Group
;****************************************************************************

;
;	IN r, (C)
;	   +-> %a0(%r10)
;
;	S	is set if input data is negative, reset otherwise
;	Z	is set if input data is zero, reset otherwise
;	H	is reset
;	P/V	is set if parity is even, reset otherwise
;	N	is reset
;	C	is not affected
;
	.global z80cpu_in
z80cpu_in:
	xsub   %sp, %sp, 8
	xld.w [%sp+0], %s0
	xld.w [%sp+4], %s1
	;
	xld.w  %r11, [%CPU+IN]
	xld.uh %r12, [%CPU+BC]		; A15:8=B
	call   %r11
	xld.w  %CPU, z80cpu		; Restore
	xld.w  %MEM, z80mem		; Restore
	ld.ub  %a0, %r10		; (߂lbit31-8NAAKv!!)
	;
	xand   %F, %F, CF		; F = F(00-PZS)
	ld.b   %t0, %a0
	or     %t0, %t0
	ld.w   %t0, %psr
	xand   %t0, %t0, ZF|SF
	or     %F, %t0
	ext z80cpu_parity@ah
	ext z80cpu_parity@al
	ld.ub  %t0, [%a0]
	or     %F, %t0
	;
	xld.w  %s0, [%sp+0]
	xld.w  %s1, [%sp+4]
	xadd   %sp, %sp, 8
	ret

;
;	OUT (C), r
;		 +-< %a0(%r10)
;
	.global z80cpu_out
z80cpu_out:
	xsub   %sp, %sp, 8
	xld.w [%sp+0], %s0
	xld.w [%sp+4], %s1
	;
	xld.w  %r11, [%CPU+OUT]
	xld.uh %r12, [%CPU+BC]		; A15:8=B
	call.d %r11
	ld.w   %r13, %r10		; *delay*
	xld.w  %CPU, z80cpu		; Restore
	xld.w  %MEM, z80mem		; Restore
	;
	xld.w  %s0, [%sp+0]
	xld.w  %s1, [%sp+4]
	xadd   %sp, %sp, 8
	ret

;****************************************************************************
;	
;****************************************************************************
